<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout column align-center justify-center>


        <v-card width="90%">
            <v-card-title>
                <v-layout row class="fab-container">

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>

                </v-layout>

                <v-layout width="100%" align-start justify-center column>
                    <v-layout wrap min-width="100%">
                        <v-text-field @change="setFilterSearch" v-model="filter.search"
                                      label="جست و جو با نام یا شماره تماس یا کد ملی"></v-text-field>

                    </v-layout>
                    <v-layout align-start justify-center class="ma-2" row>
                        <v-btn
                                color="green"
                                dark
                                small
                                top
                                center
                                @click="readData"
                        >
                            اعمال فیلتر ها
                        </v-btn>

                        <v-btn
                                color="error"
                                dark
                                small
                                top
                                center
                                @click="removeFilter"
                        >
                            حذف فیلتر ها
                        </v-btn>
                    </v-layout>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-card class="mt-2" width="90%">
            <v-card-title>
                <v-layout column>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.first_name}}</td>
                            <td>{{ item.last_name}}</td>
                            <td>{{ item.national_code}}</td>
                            <td>{{ item.username}}</td>
                            <td>{{ item.phone_number}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                        small
                                        @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>
                            <td>
                                <v-btn small class="mr-2" color="error" @click="activateItem(item)">
                                    {{ item.status === 0 ? 'فعال سازی' : 'غیرفعال سازی'}}
                                </v-btn>
                            </td>
                            <td>
                                <v-btn
                                        color="error"
                                        dark
                                        small
                                        @click="goToMarketerPanel(item)"
                                        href="/marketerMain"
                                        target="$item && '_blank'"
                                >
                                    نمایش پنل اختصاصی
                                </v-btn>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-form
                                ref="form"
                                v-model="valid"
                                lazy-validation
                        >
                            <v-layout wrap>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setFirstName" v-model="selectedItem.first_name"
                                                  label="نام"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setLastName" v-model="selectedItem.last_name"
                                                  label="نام خانوادگی"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setNationalCode" v-model="selectedItem.national_code"
                                                  label="کد ملی"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setUserName" v-model="selectedItem.username"
                                                  label="نام کاربری"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="phoneRules" @change="setPhoneNumber"
                                                  v-model="selectedItem.phone_number"
                                                  label="شماره تلفن"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setPassword" v-model="selectedItem.new_password"
                                                  label="رمز عبور جدید"></v-text-field>
                                </v-flex>
                            </v-layout>
                        </v-form>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این بازاریاب را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
                v-model="WaitDialog"
                dark
                hide-overlay
                persistent
                width="300"
        >
            <v-card
                    color="primary"
                    dark
            >
                <v-card-text>
                    لطفا منتظر بمانید
                    <v-progress-linear
                            indeterminate
                            color="white"
                            class="mb-0"
                    ></v-progress-linear>
                </v-card-text>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";
    import {saveMarketerID} from "../../data/localStorage"

    export default {
        name: "marketer",
        methods: {
            ...mapMutations({
                setFirstName: 'marketer/setFirstName',
                setLastName: 'marketer/setLastName',
                setUserName: 'marketer/setUserName',
                setPhoneNumber: 'marketer/setPhoneNumber',
                setPassword: 'marketer/setPassword',
                setSelectedItem: 'marketer/setSelectedItem',
                showAddDialog: 'marketer/showAddDialog',
                hideAddDialog: 'marketer/hideAddDialog',
                showDeleteDialog: 'marketer/showDeleteDialog',
                hideDeleteDialog: 'marketer/hideDeleteDialog',
                setFilterSearch: 'marketer/setFilterSearch',
                setNationalCode: 'marketer/setNationalCode',
                setSelectedMarketer: 'marketerMain/setSelectedMarketer',
            }),
            ...mapActions({
                removeFilter: 'marketer/removeFilter',
                readData: 'marketer/readData',
                addOrEdit: 'marketer/addOrEdit',
                deleteOne: 'marketer/deleteOne',
                activate: 'marketer/activate',

            }),
            add() {
                this.setSelectedItem({
                    id: null,
                    first_name: null,
                    last_name: null,
                    username: null,
                    new_password: null,
                    status: null,
                    phone_number: null,
                    national_code: null
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    first_name: item.first_name,
                    last_name: item.last_name,
                    username: item.username,
                    new_password: item.new_password,
                    status: item.status,
                    phone_number: item.phone_number,
                    national_code: item.national_code,
                });
                this.showAddDialog();
            },
            add_Edit() {
                if (this.$refs.form.validate()) {
                    this.addOrEdit();
                }
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },

            activateItem(item) {
                this.setSelectedItem(item);
                this.activate(item)
            },
            goToMarketerPanel(item){
                saveMarketerID(item.id);
            }
        },
        computed: {
            ...mapState({
                allData: state => state.marketer.allData,
                AllRole: state => state.marketer.AllRole,
                AddDialog: state => state.marketer.AddDialog,
                DeleteDialog: state => state.marketer.DeleteDialog,
                selectedItem: state => state.marketer.selectedItem,
                pending: state => state.marketer.pending,
                allDataLoading: state => state.marketer.allDataLoading,
                WaitDialog: state => state.marketer.WaitDialog,
                filter: state => state.marketer.filter,

            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                valid: true,
                nameRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                    v => (!v || v.length >= 4) || 'حداقل باید 4 کاراکتر بنویسید',
                ],
                numberRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                phoneRules: [
                    v => !!v || 'شماره موبایل لازم است',
                    v => (!v || v.length === 11) || 'شماره موبایل لازم است 11 رقم باشد',
                ],
                headers: [
                    {text: 'نام', align: 'right', value: 'first_name'},
                    {text: 'نام خانوادگی', align: 'right', value: 'last_name'},
                    {text: 'کد ملی', align: 'right', value: 'national_code'},
                    {text: 'نام کاربری', align: 'right', value: 'username'},
                    {text: 'شماره تلفن', align: 'right', value: 'phone_number'},
                ],
            }
        },
    }
</script>
<style scoped>
    .layout{
        min-width: 100%;
    }
</style>
